/* CWAVScrollView */
/* Copyright 1992 by David A. Cheslow, All Rights Reserved  (except those granted in the General Public License)*/


#import 	<appkit/SelectionCell.h>
#import 	<appkit/ScrollView.h>
#import	<appkit/Responder.h>
#import	<appkit/TextField.h>
#import	<appkit/ClipView.h>
#import	<appkit/Control.h>
#import	<appkit/Matrix.h>
#import	<appkit/View.h>
#import	<appkit/Box.h>

#import	<objc/Object.h>
#import 	<objc/List.h>




@interface CWAVScrollView:ScrollView
{
	id	cwavViewPrototype;
	id	cwavDelegate;
	Matrix *cwavMatrix;
	int	hasBeenSetup;
	int	adjustSize;
	float matrixBackgroundGray;
	float cellBackgroundGray;
	int 	cellBorderType;
	int 	matrixMode;
	id	matrixTarget;
}

- init;
- initFrame:(const NXRect *)frameRect;
- free;
- cwavMatrix;
- loadCWAVMatrix;
- cwavViewPrototype;
- setCWAVMatrixCellSize;
- cwavDelegate;
- read:(NXTypedStream*)stream;
- write:(NXTypedStream*)stream;
- (const char*)inspectorName;
- setMatrixBackgroundGray:(float)newGray;
- setCellBackgroundGray:(float)newGray;
- setAdjustSize:(int)flag;
- setCellBorderType:(int)newBorderType;
- (float)matrixBackgroundGray;
- (float)cellBackgroundGray;
- (int)adjustSize;
- (int)cellBorderType;
- setMatrixMode:(int)newMode;
- (int)matrixMode;
@end


/* CWAV */
/* Copyright 1992 by David A. Cheslow, All Rights Reserved */

@interface CWAV:SelectionCell
{
	View	*cwavView;
}

-init;
- free;
- cwavView;
- setCWAVView:(View *)newView;
- drawInside:(const NXRect *)cellFrame inView:controlView;
- findControlWithTag:(int) tagToFind;
@end


/* CWAVMatrix */
/* Copyright 1992 by David A. Cheslow, All Rights Reserved */

@interface CWAVMatrix:Matrix
- makeCellAt:(int)row :(int)col;
- reconnectTextPointersFor:viewToReconnect inCellView:cellView;
- (int)cellIndexOf:controlToFind;
@end


/* CWAVScrollView Categories */
/* Copyright 1992 by David A. Cheslow, All Rights Reserved */

@interface TextField(CWAVTextFieldCopier)
- disconnectTextPointers;
- reconnectNextPointerTo:newNextText;
- nextText;
- previousText;
- reconnectPreviousPointerTo:newPreviousText;
@end

@interface Object(CWAVLoader)

- loadCWAV:cellToUpdate from:(int)index;
@end

@interface Responder (CWAVResponderCopier)

- deepCopy:newSuperview :newWindow;
- setNextResponder:newResponder;
@end

@interface View (CWAVViewCopier)
- disconnectTextPointers;
- deepCopy:newSuperview :newWindow;
- setSuperview:newSuperview;
- setWindow:newWindow;
- setSubviews:newSubviews;
- (int)cellIndexOf:controlToFind;
@end

@interface Control (CWAVControlCopier)
- deepCopy:newSuperview :newWindow;
- setCell:newCell;
@end


@interface Box (CWAVBoxCopier)
- deepCopy:newSuperview :newWindow;
- setCell:newCell;
@end

@interface ScrollView (CWAVScrollViewCopier)
- deepCopy:newSuperview :newWindow;
- setContentView:newContentView;
@end

@interface ClipView (CWAVClipViewCopier)
- deepCopy:newSuperview :newWindow;
@end

@interface Matrix (CWAVMatrixCopier)
- deepCopy:newSuperview :newWindow;
- setCellList:newCellList;
- disconnectTextPointers;
- nextText;
- previousText;
- reconnectNextPointerTo:newNextText;
- reconnectPreviousPointerTo:newPreviousText;
@end

